/*!
 * AnyTouch.js v0.0.1
 * (c) 2018-2019 Russell
 * https://github.com/any86/vue-create-root
 * Released under the MIT License.
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define(['exports'], factory) :
    (global = global || self, factory(global.VueCreateRoot = {}));
}(this, function (exports) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
                t[p[i]] = s[p[i]];
        return t;
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    var throwError = function (message) {
        throw ("__PKG_NAME__: " + message);
    };

    var createRoot = function (Vue, Component, options) {
        if (options === void 0) { options = {}; }
        var _a = Object.assign({ target: 'body', isAppend: true, }, options), target = _a.target, isAppend = _a.isAppend, componentOptions = __rest(_a, ["target", "isAppend"]);
        var container = 'string' === typeof target ? document.querySelector(target) : target;
        if (!container) {
            throwError('target元素不存在');
        }
        var el = document.createElement('div');
        container.insertAdjacentElement(isAppend ? 'beforeend' : 'afterbegin', el);
        var root = new Vue({
            el: el,
            render: function (createElement) {
                return createElement(Component, componentOptions);
            }
        });
        var component = root.$children[0];
        component.$remove = function () {
            root.$destroy();
            container.removeChild(root.$el);
        };
        component.$updateProps = function (props) {
            componentOptions.props = __assign({}, componentOptions.props, props);
            root.$forceUpdate();
        };
        return component;
    };

    var install = function (Vue, _a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.prefix, prefix = _c === void 0 ? '$' : _c, _d = _b.name, name = _d === void 0 ? '$createRoot' : _d;
        var instanceCommandMap = {};
        Vue.createRoot = function (component, options) {
            if (options === void 0) { options = {}; }
            var name = options.as;
            var oneProp = options.oneProp;
            var isSingleGlobal = !!options.isSingle;
            if (undefined === name) {
                if (component.prototype instanceof Vue) {
                    name = component.options.name;
                }
                else if (undefined !== component.name) {
                    name = component.name;
                }
                else {
                    throwError("\u60A8\u4F20\u5165\u7684\u7EC4\u4EF6name\u4E3A\u7A7A! \u60A8\u53EF\u4EE5\u901A\u8FC7as\u7ED9\u8FD9\u4E2A\u547D\u4EE4\u8D77\u4E2A\u522B\u540D.");
                }
            }
            var _a = _parseName(name), scope = _a.scope, method = _a.method, UNIQUE_PATH = _a.UNIQUE_PATH;
            if (undefined === scope) {
                Vue.prototype[method] = _command;
            }
            else {
                Vue.prototype[scope] = {};
                Vue.prototype[scope][method] = _command;
            }
            function _parseName(name) {
                var method = '';
                var scope;
                if (undefined === name) {
                    throwError("\u8BF7\u7528as\u7ED9\u8FD9\u4E2A\u547D\u4EE4\u8D77\u4E2A\u522B\u540D!");
                }
                else if ('string' === typeof name) {
                    method = prefix + name;
                }
                else if (Array === name.constructor) {
                    if (1 < name.length) {
                        scope = prefix + name[0];
                        method = name[1];
                    }
                    else {
                        method = prefix + name[0];
                    }
                }
                return {
                    scope: scope,
                    method: method,
                    UNIQUE_PATH: undefined === scope ? method : [scope, method].join('.')
                };
            }
            function _command(options) {
                var _a;
                if (options === void 0) { options = {}; }
                var instance;
                var activeCommand = instanceCommandMap[UNIQUE_PATH];
                if ((options.isSingle || isSingleGlobal) && undefined !== activeCommand && 0 < activeCommand.length) {
                    instance = activeCommand[activeCommand.length - 1].instance;
                    instance.$updateProps(options);
                }
                else {
                    var props = (undefined !== oneProp && (Object !== options.constructor || oneProp in options)) ? (_a = {}, _a[oneProp] = options, _a) : options;
                    instance = createRoot(Vue, component, { props: props });
                    if (undefined === instanceCommandMap[UNIQUE_PATH]) {
                        instanceCommandMap[UNIQUE_PATH] = [];
                    }
                    var id = instance._uid;
                    instanceCommandMap[UNIQUE_PATH].push({ instance: instance, id: id });
                }
                return instance;
            }
            _command.$remove = function (_uid) {
                var e_1, _a;
                var activeCommand = instanceCommandMap[UNIQUE_PATH];
                if (undefined !== activeCommand) {
                    var length = activeCommand.length;
                    if (0 < length) {
                        if (undefined === _uid) {
                            activeCommand.pop().instance.$remove();
                        }
                        else {
                            try {
                                for (var _b = __values(activeCommand.entries()), _c = _b.next(); !_c.done; _c = _b.next()) {
                                    var _d = __read(_c.value, 2), index = _d[0], id = _d[1].id;
                                    if (_uid === id) {
                                        activeCommand[index].instance.$remove();
                                        activeCommand.splice(index, 1);
                                    }
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                        }
                    }
                }
                console.log(instanceCommandMap);
            };
        };
        Vue.createRoot.list = function () {
            return Object.keys(instanceCommandMap);
        };
        Vue.prototype[name] = function (component, options) { return createRoot(Vue, component, options); };
        Vue.prototype[name].list = Vue.createRoot.list;
    };

    exports.install = install;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=vue-create-root.umd.js.map
